	list		p=16f819
	#include	<p16F819.inc>
	errorlevel	-302

	__CONFIG _INTRC_IO & _WDT_OFF & _PWRTE_ON & _MCLR_OFF & _LVP_OFF

	cblock	20H
	bufl0
	bufh0
	bufl1
	bufh1
	bufl2
	bufh2
	bufl3
	bufh3

	refh
	refl

	speedl
	speedh

	slopel

	powerl
	powerh

	avbuf0
	avbuf1
	avbuf2
	avcnt0
	avcnt1

	avdspl
	avdsph

	cnt20u

	PORTAbuf
	PORTBbuf

	DPDT
	CNT1
	CNT2
	CNT3
	CNT4

	AARGB0
	AARGB1
	AARGB2
	BARGB0
	BARGB1
	LOOPCOUNT
	REMB0
	REMB1

	AA
	AA1
	BB
	CC
	CC1
	CC2
	bitCount

	dech
	dec100
	dec10
	dec1
	endc

count_h	EQU	78H
count_l	EQU	79H
S_TEMP	EQU	7AH
W_TEMP	EQU	7BH

eadrs	EQU	7EH
edata	EQU	7FH

eepl	EQU	0
eeph	EQU 1

;

E	SET	1		;LCD STROBE
RW	SET	2		;LCD R/W
RS	SET	3		;LCD RS

SPD	SET	2
slp_reset	SET	3
av_reset	SET	0

	org     0x000
	goto    init

	ORG	4

	MOVWF	W_TEMP
	SWAPF	STATUS,W
	CLRF	STATUS
	MOVWF	S_TEMP
	BTFSS	PIR1,TMR1IF
	GOTO	ISR_END

	BCF		PIR1,TMR1IF
	MOVLW	0F8H
	MOVWF	TMR1H
	MOVLW	30H
	MOVWF	TMR1L

	incf	count_h,f
	incfsz	count_l,f
	decf	count_h,f

ISR_END
	SWAPF	S_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

init
	bsf     STATUS,RP0
	movlw	B'11110001'
	movwf   TRISA
	movlw	B'00001111'
	movwf	TRISB
	movlw	B'01110000'
	movwf	OSCCON
	movlw	B'10001110'
	movwf	ADCON1

	bcf     STATUS,RP0
	clrf	PORTA
	clrf	PORTAbuf
	clrf	PORTB
	clrf	PORTBbuf
	movlw	B'01000000'
	movwf	ADCON0

	call	LCD_INI	
	call	LCD_CLR

	bsf     STATUS,RP0
	BSF		PIE1,TMR1IE    	
	BCF		STATUS,RP0

	MOVLW	01H
	MOVWF	T1CON

	clrf	count_h
	clrf	count_l
	MOVLW	0F8H
	MOVWF	TMR1H
	MOVLW	30H
	MOVWF	TMR1L
	BSF		INTCON,PEIE
	BSF		INTCON,GIE

;vpϐZbg
label_000c
	clrf	speedl
	clrf	speedh

	clrf	slopel

	clrf	powerl
	clrf	powerh

	clrf	avbuf0
	clrf	avbuf1
	clrf	avbuf2
	clrf	avcnt0
	clrf	avcnt1

	clrf	avdspl
	clrf	avdsph

	call	read

	call	LCD_disp

main
	btfsc	PORTB,slp_reset
	goto	main_01
	call	TIME5M
	btfsc	PORTB,slp_reset
	goto	main_01

	call	reset
	goto	label_000c
main_01

	btfsc	PORTB,av_reset
	goto	main_02
	call	TIME5M
	btfsc	PORTB,av_reset
	goto	main_02

	goto	label_000c
main_02

	btfsc	PORTB,SPD
	goto	main
main_00
	btfss	PORTB,SPD
	goto	main_00

	movfw	count_h
	movwf	BARGB0
	movfw	count_l
	movwf	BARGB1
	clrf	count_h
	clrf	count_l

	movlw	H'01'
	movwf	AARGB0
	movlw	H'26'
	movwf	AARGB1
	movlw	H'0C'
	movwf	AARGB2

	call	FXD2416U

	movfw	AARGB2
	movwf	speedl
	movfw	AARGB1
	movwf	speedh

	movfw	bufl1
	movwf	bufl0
	movfw	bufh1
	movwf	bufh0

	movfw	bufl2
	movwf	bufl1
	movfw	bufh2
	movwf	bufh1

	movfw	bufl3
	movwf	bufl2
	movfw	bufh3
	movwf	bufh2

	call	ad_conv

	bsf     STATUS,RP0
	movfw	ADRESL
	bcf     STATUS,RP0
	movwf	bufl3
	movfw	ADRESH
	movwf	bufh3

	movfw	bufl1
	addwf	bufl0,f
	movfw	bufh1
	btfsc	STATUS,C
	incf	bufh1,w
	addwf	bufh0,f

	movfw	bufl2
	addwf	bufl0,f
	movfw	bufh2
	btfsc	STATUS,C
	incf	bufh2,w
	addwf	bufh0,f

	movfw	bufl3
	addwf	bufl0,f
	movfw	bufh3
	btfsc	STATUS,C
	incf	bufh3,w
	addwf	bufh0,f

	bcf	STATUS,C
	rrf	bufh0,F
	rrf	bufl0,F
	bcf	STATUS,C
	rrf	bufh0,F
	rrf	bufl0,F

	movfw	refl
	subwf	bufl0,f
	movfw	refh
	btfss	STATUS,C
	incf	refh,w
	subwf	bufh0,f

	call	get_slope
	movwf	slopel

	movfw	speedl
	movwf	powerl
	movfw	speedh
	movwf	powerh

	bcf	STATUS,C
	rrf	powerh,F
	rrf	powerl,F
	bcf	STATUS,C
	rrf	powerh,F
	rrf	powerl,F

	call	get_fdfrr
	movwf	powerl
	clrf	powerh

	call	get_fg
	movwf	BB

	movfw	speedl
	movwf	AA1
	movfw	speedh
	movwf	AA
	call	MUL16x8

	clrf	BARGB0
	movlw	D'50'
	movwf	BARGB1

	movfw	CC
	movwf	AARGB0
	movfw	CC1
	movwf	AARGB1
	movfw	CC2
	movwf	AARGB2

	call	FXD2416U

	movfw	AARGB2
	addwf	powerl,f
	movfw	AARGB1
	btfsc	STATUS,C
	incf	AARGB1,w
	addwf	powerh,f

	incf	avcnt0,f
	incfsz	avcnt1,f
	decf	avcnt0,f

	movf	powerl,w
	addwf	avbuf2,f
	movf	powerh,w
	btfsc	STATUS,C
	incf	powerh,w
	addwf	avbuf1,f
	btfsc	STATUS,C
	incf	avbuf0,f

	movf	avcnt0,w
	movwf	BARGB0
	movf	avcnt1,w
	movwf	BARGB1
	movf	avbuf0,w
	movwf	AARGB0
	movf	avbuf1,w
	movwf	AARGB1
	movf	avbuf2,w
	movwf	AARGB2
	call	FXD2416U
	movf	AARGB1,w
	movwf	avdsph
	movf	AARGB2,w
	movwf	avdspl

	call	LCD_disp

	goto	main

reset
	call	ad_conv
	bsf     STATUS,RP0
	movfw	ADRESL
	bcf     STATUS,RP0
	movwf	refl
	movfw	ADRESH
	movwf	refh

	movlw	eepl
	movwf	eadrs
	movfw	refl
	movwf	edata
	call	ee_write

	movlw	eeph
	movwf	eadrs
	movfw	refh
	movwf	edata
	call	ee_write

	return

read
	movlw	eepl
	call	ee_read
	movwf	refl

	movlw	eeph
	call	ee_read
	movwf	refh

	return

;---------------------------------
;	EEPROM
;---------------------------------
ee_read
	banksel	EEADR
	movwf	EEADR
	banksel	EECON1
	bcf		EECON1,EEPGD
	bsf		EECON1,RD
	banksel	EEDATA
	movf	EEDATA,w
	banksel	PORTA
	return

ee_write
	movf	eadrs,w
	banksel	EEADR
	movwf	EEADR
	movf	edata,w
	movwf	EEDATA
	banksel	EECON1
	bcf		EECON1,EEPGD
	bsf		EECON1,WREN
	movlw	H'55'
	movwf	EECON2
	movlw	H'AA'
	movwf	EECON2
	bsf		EECON1,WR
	bcf		EECON1,WREN
ee_w_lp
	btfsc	EECON1,WR
	goto	ee_w_lp

	banksel	PORTA
	return

;---------------------------------
;	A/D conversion
;---------------------------------
ad_conv
	movlw	B'01000001'
	movwf	ADCON0
	call	wait20u
	bsf		ADCON0,GO
ad_lp
	btfsc	ADCON0,GO
	goto	ad_lp
	movlw	B'01001100'
	movwf	ADCON0
	return

wait20u
	movlw	D'12'
	movwf	cnt20u
wait20_lp
	decfsz	cnt20u,f
	goto	wait20_lp
	return

;---------------------------------
;	tables
;---------------------------------
	org	0x180
get_slope
	movlw	H'01'		; 100`1FF
	movwf	PCLATH
	movfw	bufl0
	sublw	D'50'
	btfss	STATUS,C
	retlw	D'255'
	movfw	bufl0
	addwf	PCL,F

	retlw	D'0'
	retlw	D'5'
	retlw	D'10'
	retlw	D'15'
	retlw	D'20'
	retlw	D'24'
	retlw	D'29'
	retlw	D'34'
	retlw	D'39'
	retlw	D'44'
	retlw	D'49'
	retlw	D'54'
	retlw	D'59'
	retlw	D'64'
	retlw	D'69'
	retlw	D'73'
	retlw	D'78'
	retlw	D'83'
	retlw	D'88'
	retlw	D'93'
	retlw	D'98'
	retlw	D'103'
	retlw	D'108'
	retlw	D'113'
	retlw	D'118'
	retlw	D'123'
	retlw	D'128'
	retlw	D'133'
	retlw	D'138'
	retlw	D'143'
	retlw	D'148'
	retlw	D'153'
	retlw	D'158'
	retlw	D'163'
	retlw	D'168'
	retlw	D'173'
	retlw	D'179'
	retlw	D'184'
	retlw	D'189'
	retlw	D'194'
	retlw	D'199'
	retlw	D'204'
	retlw	D'210'
	retlw	D'215'
	retlw	D'220'
	retlw	D'225'
	retlw	D'230'
	retlw	D'236'
	retlw	D'241'
	retlw	D'246'
	retlw	D'252'

get_fg
	movlw	H'01'
	movwf	PCLATH
	movfw	bufl0
	sublw	D'50'
	btfss	STATUS,C
	retlw	D'0'
	movfw	bufl0
	addwf	PCL,F

	retlw	D'0'
	retlw	D'4'
	retlw	D'9'
	retlw	D'13'
	retlw	D'17'
	retlw	D'21'
	retlw	D'25'
	retlw	D'30'
	retlw	D'34'
	retlw	D'38'
	retlw	D'43'
	retlw	D'47'
	retlw	D'51'
	retlw	D'56'
	retlw	D'60'
	retlw	D'63'
	retlw	D'68'
	retlw	D'72'
	retlw	D'76'
	retlw	D'81'
	retlw	D'85'
	retlw	D'89'
	retlw	D'94'
	retlw	D'98'
	retlw	D'102'
	retlw	D'106'
	retlw	D'111'
	retlw	D'115'
	retlw	D'119'
	retlw	D'123'
	retlw	D'128'
	retlw	D'132'
	retlw	D'136'
	retlw	D'140'
	retlw	D'144'
	retlw	D'149'
	retlw	D'154'
	retlw	D'158'
	retlw	D'162'
	retlw	D'166'
	retlw	D'170'
	retlw	D'174'
	retlw	D'179'
	retlw	D'183'
	retlw	D'187'
	retlw	D'191'
	retlw	D'195'
	retlw	D'200'
	retlw	D'204'
	retlw	D'208'
	retlw	D'213'

	org	0x200
get_fdfrr
	movlw	H'02'		; 200`2FF
	movwf	PCLATH
	movfw	powerl
	sublw	D'89'
	btfss	STATUS,C
	retlw	D'0'
	movfw	powerl
	addwf	PCL,F

	retlw	D'0'
	retlw	D'0'
	retlw	D'1'
	retlw	D'1'
	retlw	D'2'
	retlw	D'2'
	retlw	D'2'
	retlw	D'3'
	retlw	D'3'
	retlw	D'4'
	retlw	D'4'
	retlw	D'5'
	retlw	D'5'
	retlw	D'6'
	retlw	D'6'
	retlw	D'7'
	retlw	D'7'
	retlw	D'8'
	retlw	D'9'
	retlw	D'9'
	retlw	D'10'
	retlw	D'11'
	retlw	D'12'
	retlw	D'13'
	retlw	D'14'
	retlw	D'14'
	retlw	D'15'
	retlw	D'17'
	retlw	D'18'
	retlw	D'19'
	retlw	D'20'
	retlw	D'21'
	retlw	D'23'
	retlw	D'24'
	retlw	D'25'
	retlw	D'27'
	retlw	D'28'
	retlw	D'30'
	retlw	D'32'
	retlw	D'34'
	retlw	D'35'
	retlw	D'37'
	retlw	D'39'
	retlw	D'41'
	retlw	D'44'
	retlw	D'46'
	retlw	D'48'
	retlw	D'51'
	retlw	D'53'
	retlw	D'56'
	retlw	D'58'
	retlw	D'61'
	retlw	D'64'
	retlw	D'67'
	retlw	D'70'
	retlw	D'73'
	retlw	D'77'
	retlw	D'80'
	retlw	D'84'
	retlw	D'87'
	retlw	D'91'
	retlw	D'95'
	retlw	D'99'
	retlw	D'103'
	retlw	D'107'
	retlw	D'111'
	retlw	D'116'
	retlw	D'120'
	retlw	D'125'
	retlw	D'130'
	retlw	D'135'
	retlw	D'140'
	retlw	D'145'
	retlw	D'150'
	retlw	D'156'
	retlw	D'161'
	retlw	D'167'
	retlw	D'173'
	retlw	D'179'
	retlw	D'185'
	retlw	D'191'
	retlw	D'198'
	retlw	D'205'
	retlw	D'211'
	retlw	D'218'
	retlw	D'225'
	retlw	D'233'
	retlw	D'240'
	retlw	D'248'
	retlw	D'255'

;---------------------------------
;	to LCD
;---------------------------------
LCD_disp
	MOVLW	080H
	CALL	LCD_CMD

	movfw	speedl
	movwf	dec1
	movfw	speedh
	movwf	dech

	movlw	'S'
	call	LCD_DATA
	movlw	'p'
	call	LCD_DATA
	movlw	'e'
	call	LCD_DATA
	movlw	'e'
	call	LCD_DATA
	movlw	'd'
	call	LCD_DATA
	movlw	':'
	call	LCD_DATA
	movlw	' '
	call	LCD_DATA

	movlw	'0'
	movwf	dec100
LCD_disp_10
	movf	dech,f
	btfsc	STATUS,Z
	goto	LCD_disp_100

	movlw	D'100'
	subwf	dec1,f
	clrw
	btfss	STATUS,C
	addlw	01
	subwf	dech,F
	incf	dec100,f
	goto	LCD_disp_10

LCD_disp_100
	movlw	D'100'
	subwf	dec1,w
	btfss	STATUS,C
	goto	LCD_disp_11
	movwf	dec1	
	incf	dec100,f
	goto	LCD_disp_10
LCD_disp_11

	movlw	'0'
	movwf	dec10
LCD_disp_12
	movlw	D'10'
	subwf	dec1,w
	btfss	STATUS,C
	goto	LCD_disp_13
	movwf	dec1
	incf	dec10,f
	goto	LCD_disp_12
LCD_disp_13

	movlw	'0'
	addwf	dec1,f

	movfw	dec100
	sublw	'0'
	btfss	STATUS,Z
	goto	LCD_disp_14
	movlw	' '
	goto	LCD_disp_15	
LCD_disp_14
	movfw	dec100
LCD_disp_15
	call	LCD_DATA

	movfw	dec10
	call	LCD_DATA

	movlw	'.'
	call	LCD_DATA

	movfw	dec1
	call	LCD_DATA

	movlw	'k'
	call	LCD_DATA

	movlw	'm'
	call	LCD_DATA

	movlw	'/'
	call	LCD_DATA

	movlw	'h'
	call	LCD_DATA

;	2s

;z\
	MOVLW	0C0H
	CALL	LCD_CMD

	movfw	slopel
	movwf	dec1

	movlw	'0'
	movwf	dec100
LCD_disp_20
	movlw	D'100'
	subwf	dec1,w
	btfss	STATUS,C
	goto	LCD_disp_21
	movwf	dec1	
	incf	dec100,f
	goto	LCD_disp_20
LCD_disp_21

	movlw	'0'
	movwf	dec10
LCD_disp_22
	movlw	D'10'
	subwf	dec1,w
	btfss	STATUS,C
	goto	LCD_disp_23
	movwf	dec1
	incf	dec10,f
	goto	LCD_disp_22
LCD_disp_23

	movlw	'0'
	addwf	dec1,f

	movfw	dec100
	sublw	'0'
	btfss	STATUS,Z
	goto	LCD_disp_24
	movlw	' '
	goto	LCD_disp_25	
LCD_disp_24
	movfw	dec100
LCD_disp_25
	call	LCD_DATA

	movfw	dec10
	call	LCD_DATA

	movlw	'.'
	call	LCD_DATA

	movfw	dec1
	call	LCD_DATA

	movlw	'%'
	call	LCD_DATA

;o͂\
	movfw	powerl
	movwf	dec1
	movfw	powerh
	movwf	dech
	call	LCD_disp_30

	movfw	avdspl
	movwf	dec1
	movfw	avdsph
	movwf	dech
	call	LCD_disp_30
	return

LCD_disp_30
	movlw	' '
	call	LCD_DATA
	movlw	'0'
	movwf	dec100
LCD_disp_30_0
	movf	dech,f
	btfsc	STATUS,Z
	goto	LCD_disp_300

	movlw	D'100'
	subwf	dec1,f
	clrw
	btfss	STATUS,C
	addlw	01
	subwf	dech,F
	incf	dec100,f
	goto	LCD_disp_30_0

LCD_disp_300
	movlw	D'100'
	subwf	dec1,w
	btfss	STATUS,C
	goto	LCD_disp_31
	movwf	dec1
	incf	dec100,f
	goto	LCD_disp_30_0
LCD_disp_31

	movlw	'0'
	movwf	dec10
LCD_disp_32
	movlw	D'10'
	subwf	dec1,w
	btfss	STATUS,C
	goto	LCD_disp_33
	movwf	dec1
	incf	dec10,f
	goto	LCD_disp_32
LCD_disp_33

	movlw	'0'
	addwf	dec1,f

	movfw	dec100
	sublw	'0'
	btfss	STATUS,Z
	goto	LCD_disp_34
	movlw	' '
	call	LCD_DATA

	movfw	dec10
	sublw	'0'
	btfss	STATUS,Z
	goto	LCD_disp_36
	movlw	' '
	goto	LCD_disp_37	
LCD_disp_36
	movfw	dec10
LCD_disp_37
	call	LCD_DATA
	goto	LCD_disp_35	
LCD_disp_34
	movfw	dec100
	call	LCD_DATA
	movfw	dec10
	call	LCD_DATA

LCD_disp_35
	movfw	dec1
	call	LCD_DATA

	movlw	'W'
	call	LCD_DATA
	return


;--------------------------------------------------------------------
;	PIC Math Divide 24 bits by 16
;	http://www.piclist.com/techref/microchip/math/div/24by16.htm
;--------------------------------------------------------------------
;Inputs:
;   Dividend - AARGB0:AARGB1:AARGB2 (0 - most significant!)
;   Divisor  - BARGB0:BARGB1
;Temporary:
;   Counter  - LOOPCOUNT
;   Remainder- REMB0:REMB1
;Output:
;   Quotient - AARGB0:AARGB1:AARGB2
;
;       Size: 28
; Max timing: 4+24*(6+6+4+3+6)-1+3+2=608 cycles (with return)
; Min timing: 4+24*(6+6+5+6)-1+3+2=560 cycles (with return)
; 
FXD2416U:
        CLRF REMB0
        CLRF REMB1
        MOVLW .24
        MOVWF LOOPCOUNT
LOOPU2416
        RLF AARGB2, W           ;shift dividend left to move next bit to remainder
        RLF AARGB1, F           ;
        RLF AARGB0, F           ;

        RLF REMB1, F            ;shift carry (next dividend bit) into remainder
        RLF REMB0, F

        RLF AARGB2, F           ;finish shifting the dividend and save  carry in AARGB2.0,
                                ;since remainder can be 17 bit long in some cases
                                ;(e.g. 0x800000/0xFFFF). This bit will also serve
                                ;as the next result bit.
         
        MOVF BARGB1, W          ;substract divisor from 16-bit remainder
        SUBWF REMB1, F          ;
        MOVF BARGB0, W          ;
        BTFSS STATUS, C         ;
        INCFSZ BARGB0, W        ;
        SUBWF REMB0, F          ;

;here we also need to take into account the 17th bit of remainder, which
;is in AARGB2.0. If we don't have a borrow after subtracting from lower
;16 bits of remainder, then there is no borrow regardless of 17th bit 
;value. But, if we have the borrow, then that will depend on 17th bit 
;value. If it is 1, then no final borrow will occur. If it is 0, borrow
;will occur. These values match the borrow flag polarity.

        SKPNC                   ;if no borrow after 16 bit subtraction
         BSF AARGB2, 0          ;then there is no borrow in result. Overwrite
                                ;AARGB2.0 with 1 to indicate no
                                ;borrow.
                                ;if borrow did occur, AARGB2.0 already
                                ;holds the final borrow value (0-borrow,
                                ;1-no borrow)

        BTFSC AARGB2, 0         ;if no borrow after 17-bit subtraction
         GOTO UOK46LL           ;skip remainder restoration.

        ADDWF REMB0, F          ;restore higher byte of remainder. (w 
                                ;contains the value subtracted from it
                                ;previously)
        MOVF BARGB1, W          ;restore lower byte of remainder
        ADDWF REMB1, F          ;

UOK46LL

        DECFSZ LOOPCOUNT, f     ;decrement counter
         GOTO LOOPU2416         ;and repeat the loop if not zero.

        RETURN

; Unsigned 16*8 bit Multiply AA(16) * BB(8), Result (CC) is 24bit
; adapted from code found on www.piclist.com
;
; params 	
;	AA 0:1 (MSB:LSB) 	= number to multiply (16bit)
;	BB					= multiplier (8bit)
;   CC 0:3 (MSB:LSB)	= Product (24bit)
;
; Taking out the loops and inlining the code would save about 
; another 20-30 instructions

MUL16x8
	clrf	CC+0		;clear result
	clrf	CC+1		;
	clrf	CC+2		;
	movlw	.8		
	movwf	bitCount	;bit counter set @ number of bits in multiplier

mul_L1					;main loop here
	rlf		CC+2,f			;rotate result left (*2)
	rlf		CC+1,f			;
	rlf		CC+0,f			;
	bcf		CC+2,0			;clear LSB of result after rotation
	btfss	BB,7			;test msb of multipier
	goto	dontAdd			;if bit is clear then dont add
	movfw   AA+1      		;Add the 16 bits of AA to product
	addwf   CC+2,f      	;
	skpnc					;
	incf	CC+1,f			;
	movfw   AA				;
	addwf   CC+1,f      	;
	skpnc					;
	incf	CC+0,f			;
dontAdd
	rlf		BB,f			;rotate multiplier left
	decfsz	bitCount,f		;chk if finished all bits in multiplier
	goto	mul_L1

	return


;
;	ȉw dqĤ߂ PIC16FpKChubNxp
;	ՓN  ^ ISBN4-7741-2131-2
;

;****  LCD Data Write  ****
LCD_DATA
	MOVWF	DPDT		;save dat
	MOVF	DPDT,W		;output upper
;
	andlw	H'F0'
	iorwf	PORTBbuf,w
;
	MOVWF	PORTB
	BCF		PORTA,RW	;R/W
	BSF		PORTA,RS	;RS high
	BSF		PORTA,E		;E high
	BCF		PORTA,E		;E low
	SWAPF	DPDT,W		;output lower
;
	andlw	H'F0'
	iorwf	PORTBbuf,w
;
	MOVWF	PORTB
	BSF		PORTA,E
	BCF		PORTA,E
	CALL	LCD_BUSY
	RETURN

;****  LCD command out  *****
LCD_CMD
	MOVWF	DPDT		;save dat
	MOVF	DPDT,W		;output upper
;
	andlw	H'F0'
	iorwf	PORTBbuf,w
;
	MOVWF	PORTB
	BCF		PORTA,RW	;R/W
	BCF		PORTA,RS	;RS low
	BSF		PORTA,E		;E high
	BCF		PORTA,E		;E low
	SWAPF	DPDT,W		;output lower
;
	andlw	H'F0'
	iorwf	PORTBbuf,w
;
	MOVWF	PORTB
	BSF		PORTA,E
	BCF		PORTA,E
	CALL	LCD_BUSY
	RETURN

;****  LCD Display Clear ****
LCD_CLR
	MOVLW	01H			;clear command
	CALL	LCD_CMD
	RETURN

;****  Initialize  *****
LCD_INI
	CALL	TIME5M		;wait
	MOVLW	030H		;Function set 8bits
	MOVWF	PORTB
	BCF		PORTA,RW	;R/W
	BCF		PORTA,RS	;RS
	BSF		PORTA,E		;E high
	BCF		PORTA,E		;E low
	CALL	TIME5M		;wait
	MOVLW	030H		;Function reset 8bits 
	MOVWF	PORTB
	BCF		PORTA,RW	;R/W
	BCF		PORTA,RS	;RS
	BSF		PORTA,E		;E high
	BCF		PORTA,E		;E low
	CALL	TIME100
	MOVLW	030H		;Function reset 8bits
	MOVWF	PORTB
	BCF		PORTA,RW
	BCF		PORTA,RS
	BSF		PORTA,E
	BCF		PORTA,E
	CALL	TIME100
	MOVLW	020H		;Function set 4bits mode
	MOVWF	PORTB		;under the 8bits mode
	BCF		PORTA,RW
	BCF		PORTA,RS
	BSF		PORTA,E
	BCF		PORTA,E
	CALL	TIME100		;From here 4bits mode

	MOVLW	02EH		;function DL=0 4bit mode
	CALL	LCD_CMD
	MOVLW	08H			;Display off D=C=B=0
	CALL	LCD_CMD
	MOVLW	0CH			;Display on cursor off blink off					;D=C=1 B=0	original = 0DH
	CALL	LCD_CMD
	MOVLW	06H			;Entry I/D=1 S=0
	CALL	LCD_CMD
	RETURN


;****  LCD Busy Check  ************
LCD_BUSY
	BSF		STATUS,RP0	;Bank 1
	MOVLW	0FFH		;PORTB input
	MOVWF	TRISB
	BCF		STATUS,RP0	;Bank 0
	BCF		PORTA,RS	;RS low
	BSF		PORTA,RW	;R/W high
	BSF		PORTA,E		;E high
	MOVF	PORTB,W		;get upper
	BCF		PORTA,E		;E low
	ANDLW	0F0H		;Mask out UPPER
	MOVWF	DPDT
	SWAPF	DPDT,F		;move to lower
	BSF		PORTA,E		;E high
	MOVF	PORTB,W		;get lower
	BCF		PORTA,E		;E low
	ANDLW	0F0H		;Mask out LOWER
	IORWF	DPDT,F		;upper+lower
	SWAPF	DPDT,F
	BTFSC	DPDT,7		;BUSY flag check
	GOTO	LCD_BUSY	;retry

	BCF		PORTA,RW	;R/W low
	BSF		STATUS,RP0	;Bank 1
	movlw	B'00001111'
	movwf	TRISB      	;All of PortB is output except RB0-3
	BCF		STATUS,RP0	;Bank 0
	RETURN

		
;*********************************
;	Timer Routine
;	TIME10  :10usec
;	TIME100 :100usec
;	TIME1M  :1msec
;	TIME5M  :5msec
;*********************************


TIME100					;100usec
	MOVLW	8H		
	MOVWF	CNT1		
T_LP1
	CALL	TIME10		;2+(26+3)*9-1=262		
	DECFSZ	CNT1,F
	GOTO	T_LP1
	nop
	nop
	movlw	2H
	goto	TIME10_0

TIME10					;10usec
	MOVLW	5H
TIME10_0
	MOVWF	CNT2		
T_LP2
	DECFSZ	CNT2,F		;2+3*7-1=22		
	GOTO	T_LP2		
	RETURN				;22+2=24

TIME1M					;1msec(about)
	MOVLW	0AH
	MOVWF	CNT3
T_LP3
	CALL	TIME100		;2+(266+3)*10-1=2691
	DECFSZ	CNT3,F
	GOTO	T_LP3
	RETURN				;2692

TIME5M					;5msec(about)
	MOVLW	38H
	MOVWF	CNT4
T_LP4
	CALL	TIME100		;2+(266+3)*56-1=15064
	DECFSZ	CNT4,F
	GOTO	T_LP4
	RETURN				;15066

;--------------------------------------------------------------------
;	initialize EEPROM 
;--------------------------------------------------------------------
	org	0x2100
	de	60H, 02H

	END


